def imageName = 'calvinrahmat/react1:v4'
def builderImage

pipeline {
    agent any

    stages {
        stage('Build Image') {
            steps {
                script {
                    builderImage = docker.build("${imageName}")
                }
            }
        }
        stage('Testing image') {
            steps {
                script {
                    builderImage.inside {
                        sh 'echo test image success'
                    }
                }
            }
        }
        stage('Push image') {
            steps {
                script {
                    builderImage.push()
                }
            }
        }
        stage('Deploy') {
            steps {
                script {
                    sshPublisher(
                    publishers: [
                        sshPublisherDesc(
                            configName: 'deploy',
                            verbose: false,
                            transfers: [
                                sshTransfer(
                                    sourceFiles: 'docker-compose.yaml',
                                    execCommand: 'cd /home/ubuntu/deploy; docker-compose up -d;',
                                    execTimeout: 120000,
                                )
                            ]
                        )
                    ]
                )
                }
            }
        }
    }
}
